fixes
[distro-setup] / switch-mail-host
index 21d988251f31dd7e88a2cc5ee13fee808faacbf2..f1cb21272e6a057b41d5e49554b765fc1e98af90 100644 (file)
@@ -1,6 +1,6 @@
 #!/bin/bash
 
-source /usr/local/lib/err
+set -e; . /usr/local/lib/bash-bear; set +e
 
 usage() {
   cat <<EOF
@@ -126,7 +126,7 @@ if ! $force && { $check_installed || [[ $direction == push ]]; } ; then
       uninstalled-file-die $f
     fi
   done
-  if ! diff -q /a/bin/errhandle/err /usr/local/lib/err; then
+  if ! diff -q /a/bin/bash-bear-trap/bash-bear /usr/local/lib/bash-bear; then
     uninstalled-file-die err
   fi
   if $check_installed; then
@@ -161,14 +161,25 @@ case $direction in
           die "failed: $old_shell switch-mail-host --check-installed"
         fi
       fi
-      tmpf=$(mktemp)
-      m scp -F $HOME/.ssh/confighome root@$old_host:/usr/local/bin/switch-mail-host $tmpf
-      if ! diff -q $tmpf ${BASH_SOURCE[0]}; then
+      tmpd=$(mktemp -d)
+      files=(
+        /usr/local/{bin/{unsaved-buffers{,.el},switch-mail-host},lib/bash-bear}
+      )
+      m scp -F $HOME/.ssh/confighome \
+        ${files@/#/root@$old_host:} $tmpd
+      diff=false
+      for f in ${files[@]}; do
+        if ! diff -q $tmpd/${f##*/} $f; then
+          m install -T $tmpd/${f##*/} $f
+          diff=true
+        fi
+      done
+      if $diff; then
         e "found different version on old_host=$old_hostname, reexecing"
-        m install -T $tmpf /usr/local/bin/switch-mail-host
         m /usr/local/bin/switch-mail-host --pull-reexec "${orig_args[@]}"
-        mexit 0
+        exit 0
       fi
+      rm -r -- $tmpd
     fi
 
     f=/a/bin/bash_unpublished/source-state
@@ -259,16 +270,7 @@ done
 # ensure these are unused before doing anything
 e "On $new_host: umounting /m and /o, checking emacs"
 {
-  cat <<'EOF'
-set -eE
-if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
-  bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
-  if [[ $bufs ]]; then
-    echo "error: on $HOSTNAME, unsaved emacs files: $bufs" >&2
-    exit 1
-  fi
-fi
-EOF
+  cat /usr/local/bin/unsaved-buffers
   if ! $host2_only; then
     cat <<EOF
 for dir in m o; do
@@ -281,15 +283,18 @@ EOF
   fi
 } | $new_shell bash -s
 
-$old_shell bash -s <<'EOF'
-if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
-  bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
-  if [[ $bufs ]]; then
-    echo "error: on $HOSTNAME, unsaved emacs files: $bufs" >&2
-    exit 1
-  fi
+if ! $mail_only; then
+  cat /usr/local/bin/unsaved-buffers - <<'EOF' |  $old_shell bash -s
+
+# Try to prevent emacs from saving stale data it has in memory to disk. eg: files, recentf list, etc.
+# But if emacs ignores the signal, let it live.
+pkill -xf 'emacs( --daemon| -f znc-all)' ||:
+
+if [[ -e /p/profanity-here ]]; then
+  systemctl disable --now profanity
 fi
 EOF
+fi
 
 # previously, I was checking to see if the new mail host
 # is on my home network, then changing my home dns
@@ -323,6 +328,9 @@ if $host2_only; then
     m $old_shell systemctl --now disable btrbk.timer
   fi
   m $new_shell systemctl --now enable btrbk.timer
+  if [[ -e /p/profanity-here ]]; then
+    m $new_shell systemctl --now enable profanity
+  fi
   exit 0
 fi
 
@@ -332,9 +340,6 @@ if (( ret )); then
   exit $ret
 fi
 
-# Try to prevent emacs from saving stale data it has in memory to disk. eg: files, recentf list, etc.
-# But if emacs ignores the signal, let it live.
-m $new_shell killall -q emacs ||:
 
 e Running main btrbk
 m btrbk-run -v --fast $bbk_args $force_arg $incremental_arg -m /o || ret=$?
@@ -363,4 +368,12 @@ if (( ret )); then
   exit $ret
 fi
 
+if ! $mail_only && [[ -e /p/profanity-here ]]; then
+  m $new_shell systemctl --now enable profanity || ret=$?
+  if (( ret )); then
+    err "failed final systemctl --now enable profanity, just fix and rerun"
+    exit $ret
+  fi
+fi
+
 m exit 0